/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.flexiblearraylist;

import java.time.LocalTime;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 *
 * @author omozegieaziegbe
 */
// Define a custom object class
class CustomObject {

    private String name;

    public CustomObject(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }
}

public class FlexibleArrayList {

    public static void main(String[] args) {

        ArrayList<Object> flexibleList = new ArrayList<>();

        // Adding elements of different types
        flexibleList.add("Hello");          // Adding a String
        flexibleList.add(10);               // Adding an Integer
        flexibleList.add(3.14);             // Adding a Double
        flexibleList.add(true);             // Adding a Boolean
        flexibleList.add(LocalTime.now());  // Adding a LocalTime
        flexibleList.add(Arrays.asList(1, 2, 3));  // Adding a List
        flexibleList.add(new CustomObject("Array with Multiple Data types")); // Adding a CustomObject

        // Retrieving objects using pattern matching
        for (Object obj : flexibleList) {
            if (obj instanceof String s) {
                // Code block if obj is a String, with s as its reference
                System.out.println("String: " + s);
            } else if (obj instanceof Integer i) {
                // Code block if obj is an Integer, with i as its reference
                System.out.println("Integer: " + i);
            } else if (obj instanceof Double d) {
                // Code block if obj is a Double, with d as its reference
                System.out.println("Double: " + d);
            } else if (obj instanceof Boolean b) {
                // Code block if obj is a Boolean, with b as its reference
                System.out.println("Boolean: " + b);
            } else if (obj instanceof LocalTime t) {
                // Code block if obj is a LocalTime, with t as its reference
                System.out.println("LocalTime: " + t.toString());
            } else if (obj instanceof List l) {
                // Code block if obj is a List, with l as its reference  
                System.out.println("List: " + l);
            } else if (obj instanceof CustomObject customObj) {
                // Code block if obj is a Custom Object, with customObj as its reference  
                System.out.println("CustomObject: " + customObj.getName());
            } else {
                // Code block if obj is of another type
            }
        }

    }
}
