/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg.guavaexample;

import com.google.common.collect.ArrayListMultimap;
import com.google.common.collect.Multimap;
import java.time.LocalTime;
import java.util.Arrays;
import java.util.List;

/**
 *
 * @author omozegieaziegbe
 */
public class GuavaExample {

    public static void main(String[] args) {
        Multimap<String, Object> multiTypeList = ArrayListMultimap.create();
        
        // Adding elements of different types
        multiTypeList.put("String", "Hello");                           // Adding a String
        multiTypeList.put("Integer", 10);                               // Adding an Integer
        multiTypeList.put("Double", 3.14);                              // Adding a Double
        multiTypeList.put("Boolean", true);                             // Adding a Boolean
        multiTypeList.put("LocalTime", LocalTime.now());                // Adding a LocalTime
        multiTypeList.put("List", Arrays.asList(1, 2, 3));              // Adding a List
        multiTypeList.put("CustomObject", new CustomObject("CustomObject")); // Adding a CustomObject
        
        // Retrieving elements
        for (String key : multiTypeList.keySet()) {
            List<Object> values = (List<Object>) multiTypeList.get(key);
            System.out.println(key + ": " + values);
        }
    }
    
    // Define a custom object class
    static class CustomObject {
        private String name;

        public CustomObject(String name) {
            this.name = name;
        }

        public String getName() {
            return name;
        }
    }
}